import { Component as IntactComponent, Props, VNodeComponentClass } from 'intact';
import { Component as ReactComponent, ReactNode, Provider, HTMLAttributes, ReactChild, ReactElement } from 'react';
import { normalizeChildren } from './normalize';
import { functionalWrapper } from './functionalWrapper';
import { FakePromise, FakePromises } from './fakePromise';
export * from 'intact';
export { normalizeChildren as normalize };
declare type ValidReactNode = ReactChild | null | undefined;
declare type OnEvents<E> = {
    [K in keyof E as `on${Capitalize<string & K>}`]: E[K];
};
declare type IntactReactProps<P, E, B> = Readonly<P> & Readonly<{
    children?: ReactNode | undefined;
    className?: string;
    style?: string | Record<string, string | number>;
}> & Readonly<{
    [K in keyof P as `onChange${Capitalize<string & K>}`]?: (oldValue: P[K], newValue: P[K]) => void;
}> & Readonly<{
    [K in keyof E as `on${Capitalize<string & K>}`]?: (...args: E[K]) => void;
}> & Readonly<{
    [K in keyof B as `slot${Capitalize<string & K>}`]?: B[K] extends null ? ValidReactNode : (data: B[K]) => ValidReactNode;
}> & Readonly<Omit<NormalizedHTMLAttibutes, keyof P | keyof OnEvents<E> | 'style'>>;
declare type NormalizedHTMLAttibutes = {
    [Key in keyof HTMLAttributes<any>]: Key extends `on${infer Name}` ? GlobalEventHandlers[Lowercase<Key>] : HTMLAttributes<any>[Key];
};
export declare class Component<P = {}, E = {}, B = {}> extends IntactComponent<P, E, B> implements ReactComponent {
    static $cid: string;
    static normalize: typeof normalizeChildren;
    static functionalWrapper: typeof functionalWrapper;
    static contextType: import("react").Context<Component<{}, {}, {}> | null>;
    static FakePromise: typeof FakePromise;
    static $doubleVNodes: boolean;
    context: any;
    state: any;
    props: IntactReactProps<P, E, B>;
    isReactComponent: boolean;
    $promises: FakePromises;
    $reactProviders: Map<Provider<any>, any>;
    private $parentPromises;
    private $elementRef;
    private $elementAlternateRef;
    private $isReact;
    private $parentElement;
    private $pendingUnmount?;
    constructor(props: IntactReactProps<P, E, B>, context: any);
    constructor(props: Props<P, Component<P>> | null, $vNode: VNodeComponentClass, $SVG: boolean, $mountedQueue: Function[], $senior: Component | null);
    render(): ReactElement<any, string | import("react").JSXElementConstructor<any>> | ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    private $done;
    setState(): void;
    $mount(lastVNode: VNodeComponentClass<this> | null, nextVNode: VNodeComponentClass<this>): void;
    $unmount(vNode: VNodeComponentClass<this>, nextVNode: VNodeComponentClass<this> | null): void;
}
