import { ComponentClass, RefObject, NonNullableRefObject, Ref } from './types';
export declare function isRef(o: any): o is RefObject<any>;
export declare function createRef<T = Element>(): RefObject<T>;
export declare function createRef<T = Element>(defaultValue: T): NonNullableRefObject<T>;
/**
 * We must mount ref after all operations completed, because when we patch children,
 * one child will be mounted before being removed. e.g.
 * patchTest(
 *     h('div', null, [h('div'), h('div', {ref})]),
 *     h('div', null, [h('div', {ref})]),
 * );
 */
export declare function mountRef(ref: Ref<ComponentClass> | Ref<Element> | Ref<ComponentClass | Element> | null | undefined, value: any, mountedQueue: Function[] & {
    i?: number;
}): void;
export declare function unmountRef(ref?: Ref<ComponentClass> | Ref<Element> | Ref<ComponentClass | Element> | null): void;
